# std::multimap< _Key, _Tp, _Compare, _Alloc > Class Template Reference
[Containers, Associative Containers]

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time. More...

`#include <stl_multimap.h>`

List of all members.

## Public Methods

| multimap ()
| Default constructor creates no elements.
| multimap (const _Compare &__comp, const allocator_type &__a=allocator_type())
| Default constructor creates no elements.
| multimap (const multimap &__x)
| %Multimap copy constructor.
template<typename _InputIterator> | multimap (_InputIterator __first, _InputIterator __last)
| Builds a %multimap from a range.
template<typename _InputIterator> | multimap (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
| Builds a %multimap from a range.
multimap & | operator= (const multimap &__x)
| %Multimap assignment operator.
allocator_type | get_allocator () const
| Get a copy of the memory allocation object.
iterator | begin ()
const_iterator | begin () const
iterator | end ()
const_iterator | end () const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
bool | empty () const
size_type | size () const
size_type | max_size () const
iterator | insert (const value_type &__x)
| Inserts a std::pair into the %multimap.
iterator | insert (iterator __position, const value_type &__x)
| Inserts a std::pair into the %multimap.
template<typename _InputIterator> void | insert (_InputIterator __first, _InputIterator __last)
| A template function that attemps to insert a range of elements.
void | erase (iterator __position)
| Erases an element from a %multimap.
size_type | erase (const key_type &__x)
| Erases elements according to the provided key.
void | erase (iterator __first, iterator __last)
| Erases a [first,last) range of elements from a %multimap.
void | swap (multimap &__x)
| Swaps data with another %multimap.
void | clear ()
key_compare | key_comp () const
value_compare | value_comp () const
iterator | find (const key_type &__x)
| Tries to locate an element in a %multimap.
const_iterator | find (const key_type &__x) const
| Tries to locate an element in a %multimap.
size_type | count (const key_type &__x) const
| Finds the number of elements with given key.
iterator | lower_bound (const key_type &__x)
| Finds the beginning of a subsequence matching given key.
const_iterator | lower_bound (const key_type &__x) const
| Finds the beginning of a subsequence matching given key.
iterator | upper_bound (const key_type &__x)
| Finds the end of a subsequence matching given key.
const_iterator | upper_bound (const key_type &__x) const
| Finds the end of a subsequence matching given key.
pair< iterator, iterator > | equal_range (const key_type &__x)
| Finds a subsequence matching given key.
pair< const_iterator, const_iterator > | equal_range (const key_type &__x) const
| Finds a subsequence matching given key.

## Detailed Description

### template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
class std::multimap< _Key, _Tp, _Compare, _Alloc >

A standard container made up of (key,value) pairs, which can be retrieved based on a key, in logarithmic time.

Meets the requirements of a container, a reversible container, and an associative container (using equivalent keys). For a `multimap<Key,T>` the key_type is Key, the mapped_type is T, and the value_type is std::pair<const Key,T>.

Multimaps support bidirectional iterators.

Definition at line 105 of file stl_multimap.h.

## Constructor & Destructor Documentation

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
std::multimap< _Key, _Tp, _Compare, _Alloc >::multimap | ( |  | ) | `[inline]`

| Default constructor creates no elements. Definition at line 157 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
std::multimap< _Key, _Tp, _Compare, _Alloc >::multimap | ( | const _Compare & | __comp,
|  | const allocator_type & | __a = allocator_type()
| ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 164 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
std::multimap< _Key, _Tp, _Compare, _Alloc >::multimap | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x | ) | `[inline]`

%Multimap copy constructor.

Parameters:

  x | A %multimap of identical element and allocator types.

The newly-created %multimap uses a copy of the allocation object used by x.

Definition at line 174 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
template<typename _InputIterator>
std::multimap< _Key, _Tp, _Compare, _Alloc >::multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

Builds a %multimap from a range.

Parameters:

  first | An input iterator.
  last | An input iterator.

Create a %multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 187 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
template<typename _InputIterator>
std::multimap< _Key, _Tp, _Compare, _Alloc >::multimap | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp,
|  | const allocator_type & | __a = allocator_type()
| ) | `[inline]`

Builds a %multimap from a range.

Parameters:

  first | An input iterator.
  last | An input iterator.
  comp | A comparison functor.
  a | An allocator object.

Create a %multimap consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 203 of file stl_multimap.h.

## Member Function Documentation

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::begin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points to the first pair in the %multimap. Iteration is done in ascending order according to the keys. Definition at line 250 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::begin | ( |  | ) | `[inline]`

| Returns a read/write iterator that points to the first pair in the %multimap. Iteration is done in ascending order according to the keys. Definition at line 242 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
void std::multimap< _Key, _Tp, _Compare, _Alloc >::clear | ( |  | ) | `[inline]`

| Erases all elements in a %multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty. Definition at line 425 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
size_type std::multimap< _Key, _Tp, _Compare, _Alloc >::count | ( | const key_type & | __x | ) | const`[inline]`

Finds the number of elements with given key.

Parameters:

  x | Key of (key, value) pairs to be located.

Returns:
  Number of elements with specified key.

Definition at line 477 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
bool std::multimap< _Key, _Tp, _Compare, _Alloc >::empty | ( |  | ) | const`[inline]`

| Returns true if the %multimap is empty. Definition at line 302 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::end | ( |  | ) | const`[inline]`

| Returns a read-only (constant) iterator that points one past the last pair in the %multimap. Iteration is done in ascending order according to the keys. Definition at line 265 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::end | ( |  | ) | `[inline]`

| Returns a read/write iterator that points one past the last pair in the %multimap. Iteration is done in ascending order according to the keys. Definition at line 257 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
pair<const_iterator,const_iterator> std::multimap< _Key, _Tp, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) | const`[inline]`

Finds a subsequence matching given key.

Parameters:

  x | Key of (key, value) pairs to be located.

Returns:
  Pair of read-only (constant) iterators that possibly points to the subsequence matching given key.

This function returns a pair of which the first element possibly points to the first element matching the given key and the second element possibly points to the last element matching the given key. If unsuccessful the first element of the returned pair will contain an iterator pointing to the next greatest element or, if no such a greater element exists, to end().

Definition at line 554 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
pair<iterator,iterator> std::multimap< _Key, _Tp, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  x | Key of (key, value) pairs to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function returns a pair of which the first element possibly points to the first element matching the given key and the second element possibly points to the last element matching the given key. If unsuccessful the first element of the returned pair will contain an iterator pointing to the next greatest element or, if no such greater element exists, to end().

Definition at line 538 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
void std::multimap< _Key, _Tp, _Compare, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last
| ) | `[inline]`

Erases a [first,last) range of elements from a %multimap.

Parameters:

  first | Iterator pointing to the start of the range to be erased.
  last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a %multimap. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 402 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
size_type std::multimap< _Key, _Tp, _Compare, _Alloc >::erase | ( | const key_type & | __x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all elements located by the given key from a %multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 389 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
void std::multimap< _Key, _Tp, _Compare, _Alloc >::erase | ( | iterator | __position | ) | `[inline]`

Erases an element from a %multimap.

Parameters:

  position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a %multimap. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 375 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::find | ( | const key_type & | __x | ) | const`[inline]`

Tries to locate an element in a %multimap.

Parameters:

  x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns a constant iterator pointing to the sought after %pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 469 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::find | ( | const key_type & | __x | ) | `[inline]`

Tries to locate an element in a %multimap.

Parameters:

  x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after %pair. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 455 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
allocator_type std::multimap< _Key, _Tp, _Compare, _Alloc >::get_allocator | ( |  | ) | const`[inline]`

| Get a copy of the memory allocation object. Definition at line 234 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
template<typename _InputIterator>
void std::multimap< _Key, _Tp, _Compare, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last
| ) | `[inline]`

A template function that attemps to insert a range of elements.

Parameters:

  first | Iterator pointing to the start of the range to be inserted.
  last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 362 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::insert | ( | iterator | __position,
|  | const value_type & | __x
| ) | `[inline]`

Inserts a std::pair into the %multimap.

Parameters:

  position | An iterator that serves as a hint as to where the pair should be inserted.
  x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the %multimap. Contrary to a std::map the %multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on "hinting".

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 349 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::insert | ( | const value_type & | __x | ) | `[inline]`

Inserts a std::pair into the %multimap.

Parameters:

  x | Pair to be inserted (see std::make_pair for easy creation of pairs).

Returns:
  An iterator that points to the inserted (key,value) pair.

This function inserts a (key, value) pair into the %multimap. Contrary to a std::map the %multimap does not rely on unique keys and thus multiple pairs with the same key can be inserted.

Insertion requires logarithmic time.

Definition at line 326 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
key_compare std::multimap< _Key, _Tp, _Compare, _Alloc >::key_comp | ( |  | ) | const`[inline]`

| Returns the key comparison object out of which the %multimap was constructed. Definition at line 433 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) | const`[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to first element matching given key, or end() if not found.

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful the iterator will point to the next greatest element or, if no such greater element exists, to end().

Definition at line 505 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to first element matching given key, or end() if not found.

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 491 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
size_type std::multimap< _Key, _Tp, _Compare, _Alloc >::max_size | ( |  | ) | const`[inline]`

| Returns the maximum size of the %multimap. Definition at line 310 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
multimap& std::multimap< _Key, _Tp, _Compare, _Alloc >::operator= | ( | const multimap< _Key, _Tp, _Compare, _Alloc > & | __x | ) | `[inline]`

%Multimap assignment operator.

Parameters:

  x | A %multimap of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 226 of file stl_multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Alloc >::_M_t .

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_reverse_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::rbegin | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to the last pair in the %multimap. Iteration is done in descending order according to the keys. Definition at line 281 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
reverse_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::rbegin | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to the last pair in the %multimap. Iteration is done in descending order according to the keys. Definition at line 273 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_reverse_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::rend | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reverse iterator that points to one before the first pair in the %multimap. Iteration is done in descending order according to the keys. Definition at line 297 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
reverse_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::rend | ( |  | ) | `[inline]`

| Returns a read/write reverse iterator that points to one before the first pair in the %multimap. Iteration is done in descending order according to the keys. Definition at line 289 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
size_type std::multimap< _Key, _Tp, _Compare, _Alloc >::size | ( |  | ) | const`[inline]`

| Returns the size of the %multimap. Definition at line 306 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
void std::multimap< _Key, _Tp, _Compare, _Alloc >::swap | ( | multimap< _Key, _Tp, _Compare, _Alloc > & | __x | ) | `[inline]`

Swaps data with another %multimap.

Parameters:

  x | A %multimap of the same element and allocator types.

This exchanges the elements between two multimaps in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(m1,m2) will feed to this function.

Definition at line 416 of file stl_multimap.h.

References std::multimap< _Key, _Tp, _Compare, _Alloc >::_M_t .

Referenced by std::swap() .

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
const_iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) | const`[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  x | Key of (key, value) pair to be located.

Returns:
  Read-only (constant) iterator pointing to last element matching given key.

Definition at line 522 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
iterator std::multimap< _Key, _Tp, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  x | Key of (key, value) pair to be located.

Returns:
  Iterator pointing to last element matching given key.

Definition at line 513 of file stl_multimap.h.

template<typename _Key, typename _Tp, typename _Compare, typename _Alloc>
value_compare std::multimap< _Key, _Tp, _Compare, _Alloc >::value_comp | ( |  | ) | const`[inline]`

| Returns a value comparison object, built from the key comparison object out of which the %multimap was constructed. Definition at line 440 of file stl_multimap.h.

The documentation for this class was generated from the following file:

- stl_multimap.h